SystemOrganization addCategory: #Metaprogramacion!

TestCase subclass: #MetaprogramacionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!MetaprogramacionTests methodsFor: 'methods' stamp: 'AlejandraRodriguez 6/24/2013 03:03'!
abstractMethodOfAClassWithoutSubclasses
	^ SampleClassWithNoSubclasses>>#anAbstractMethod! !

!MetaprogramacionTests methodsFor: 'methods' stamp: 'AlejandraRodriguez 6/24/2013 03:01'!
methodDefinedInAllOneLevelSubclasses
	^ SampleClassWithOneLevelOfSubclasses>>#aSubclassDefinedMethod! !

!MetaprogramacionTests methodsFor: 'methods' stamp: 'AlejandraRodriguez 6/24/2013 03:04'!
methodDefinedInAllSubclasses
	^ SampleClassWithTwoLevelsOfSubclasses>>#aSubclassDefinedMethod! !

!MetaprogramacionTests methodsFor: 'methods' stamp: 'AlejandraRodriguez 6/24/2013 03:03'!
methodNotDefinedForOneOfTheOneLevelSubclasses
	^ SampleClassWithOneLevelOfSubclasses>>#aMethodNotDefinedForOneTheOneLevelSubclasses! !

!MetaprogramacionTests methodsFor: 'methods' stamp: 'AlejandraRodriguez 6/24/2013 03:02'!
methodNotDefinedForOneOfTheTwoLevelSubclasses
	^ SampleClassWithTwoLevelsOfSubclasses>>#aMethodNotDefinedForOneTheTwoLevelSubclasses! !

!MetaprogramacionTests methodsFor: 'methods' stamp: 'AlejandraRodriguez 6/24/2013 03:12'!
methodNotImplementedInTwoLevelSubclassesButImplementedInAllOneLevelSubclasses
	^ SampleClassWithTwoLevelsOfSubclasses>>#aMethodImplementedInOneLevelSubclasses! !

!MetaprogramacionTests methodsFor: 'methods' stamp: 'AlejandraRodriguez 6/21/2013 18:51'!
nonAbstractCompiledMethod
	^ SampleClassToTestProgrammingErrorsDetector>>#nonAbstractMethod! !

!MetaprogramacionTests methodsFor: 'methods' stamp: 'AlejandraRodriguez 6/24/2013 03:29'!
nonAbstractMethodOfAClassWithoutSubclasses
	^ SampleClassWithNoSubclasses>>#nonAbstractMethodOfAClassWithoutSubclasses! !

!MetaprogramacionTests methodsFor: 'tests' stamp: 'AlejandraRodriguez 6/24/2013 03:00'!
test01IfAMethodIsNotAbstractThenItWillBeConsideredDefined

	| aProgrammingErrorsDetector |

	aProgrammingErrorsDetector := ProgrammingErrorsDetector new.
	self deny: (aProgrammingErrorsDetector methodIsUndefinedForSubclases: self nonAbstractCompiledMethod).
	self assert: (aProgrammingErrorsDetector allSubclassesForWhomIsUndefinedTheMethod: self nonAbstractCompiledMethod) isEmpty.! !

!MetaprogramacionTests methodsFor: 'tests' stamp: 'AlejandraRodriguez 6/24/2013 03:19'!
test02IfAMethodIsAbstractAndThereIsNotSubclassesThenItIsUndefinedForSubclassesAndTheListOfSubclassesForWhomIsUndefinedMustBeEmpty

	| aProgrammingErrorsDetector |

	aProgrammingErrorsDetector := ProgrammingErrorsDetector new.
	self assert: (aProgrammingErrorsDetector methodIsUndefinedForSubclases: self abstractMethodOfAClassWithoutSubclasses).
	self assert: (aProgrammingErrorsDetector allSubclassesForWhomIsUndefinedTheMethod: self abstractMethodOfAClassWithoutSubclasses) isEmpty.! !

!MetaprogramacionTests methodsFor: 'tests' stamp: 'AlejandraRodriguez 6/24/2013 03:01'!
test03IfAMethodIsAbstractAndAllOfItsOneLevelSubclassesDefineItThenIsDefinedAndTheListOfSubclassesMustBeEmpty

	| aProgrammingErrorsDetector |

	aProgrammingErrorsDetector := ProgrammingErrorsDetector new.
	self deny: (aProgrammingErrorsDetector methodIsUndefinedForSubclases: self methodDefinedInAllOneLevelSubclasses).
	self assert: (aProgrammingErrorsDetector allSubclassesForWhomIsUndefinedTheMethod: self methodDefinedInAllOneLevelSubclasses) isEmpty.! !

!MetaprogramacionTests methodsFor: 'tests' stamp: 'AlejandraRodriguez 6/24/2013 03:04'!
test04IfAMethodIsAbstractAndAllOfItsAnyLevelSubclassesHaveDefinedItThenIsDefinedAndTheListOfSubclassesMustBeEmpty

	| aProgrammingErrorsDetector |

	aProgrammingErrorsDetector := ProgrammingErrorsDetector new.
	self deny: (aProgrammingErrorsDetector methodIsUndefinedForSubclases: self methodDefinedInAllSubclasses).
	self assert: (aProgrammingErrorsDetector allSubclassesForWhomIsUndefinedTheMethod: self methodDefinedInAllSubclasses) isEmpty.! !

!MetaprogramacionTests methodsFor: 'tests' stamp: 'AlejandraRodriguez 6/24/2013 03:03'!
test05IfAMethodIsAbstractAndOneOfItsOneLevelSubclassesNotDefineItThenIsNotDefinedForAllAndTheListOfSubclassesMustBeThatSubclass

	| aProgrammingErrorsDetector |

	aProgrammingErrorsDetector := ProgrammingErrorsDetector new.
	self assert: (aProgrammingErrorsDetector methodIsUndefinedForSubclases: self methodNotDefinedForOneOfTheOneLevelSubclasses).
	self assert:  (aProgrammingErrorsDetector allSubclassesForWhomIsUndefinedTheMethod: self methodNotDefinedForOneOfTheOneLevelSubclasses) size == 1.
	self assert: ( (aProgrammingErrorsDetector allSubclassesForWhomIsUndefinedTheMethod: self methodNotDefinedForOneOfTheOneLevelSubclasses) includes: self theOneLevelSubclassHasNotDefinedTheMethod ).! !

!MetaprogramacionTests methodsFor: 'tests' stamp: 'AlejandraRodriguez 6/24/2013 03:02'!
test06IfAMethodIsAbstractAndOneOfItsSubclassesNotDefineItThenIsNotDefinedForAllAndTheListOfSubclassesMustBeThatSubclass

	| aProgrammingErrorsDetector |

	aProgrammingErrorsDetector := ProgrammingErrorsDetector new.
	self assert: (aProgrammingErrorsDetector methodIsUndefinedForSubclases: self methodNotDefinedForOneOfTheTwoLevelSubclasses).
	self assert:  (aProgrammingErrorsDetector allSubclassesForWhomIsUndefinedTheMethod: self methodNotDefinedForOneOfTheTwoLevelSubclasses) size == 1.
	self assert: ( (aProgrammingErrorsDetector allSubclassesForWhomIsUndefinedTheMethod: self methodNotDefinedForOneOfTheTwoLevelSubclasses) includes: self theTwoLevelSubclassHasNotDefinedTheMethod ).! !

!MetaprogramacionTests methodsFor: 'tests' stamp: 'AlejandraRodriguez 6/24/2013 03:08'!
test07IfAMethodIsAbstractAndTheTwoLevelSubclassesNotImplementItButAllOfTheOneLevelSubclassesImplementItThenIsDefined

	| aProgrammingErrorsDetector |

	aProgrammingErrorsDetector := ProgrammingErrorsDetector new.
	self deny: (aProgrammingErrorsDetector methodIsUndefinedForSubclases: self methodNotImplementedInTwoLevelSubclassesButImplementedInAllOneLevelSubclasses).
	self assert:  (aProgrammingErrorsDetector allSubclassesForWhomIsUndefinedTheMethod: self methodNotImplementedInTwoLevelSubclassesButImplementedInAllOneLevelSubclasses) isEmpty.! !

!MetaprogramacionTests methodsFor: 'tests' stamp: 'AlejandraRodriguez 6/24/2013 03:28'!
test08IfAMethodIsAbstractAndThereIsNotSubclassesThenItIsDefined

	| aProgrammingErrorsDetector |

	aProgrammingErrorsDetector := ProgrammingErrorsDetector new.
	self deny: (aProgrammingErrorsDetector methodIsUndefinedForSubclases: self nonAbstractMethodOfAClassWithoutSubclasses).
	self assert: (aProgrammingErrorsDetector allSubclassesForWhomIsUndefinedTheMethod: self nonAbstractMethodOfAClassWithoutSubclasses) isEmpty.! !

!MetaprogramacionTests methodsFor: 'classes' stamp: 'AlejandraRodriguez 6/24/2013 02:36'!
theOneLevelSubclassHasNotDefinedTheMethod
	^ SampleOneLevelSubClassB! !

!MetaprogramacionTests methodsFor: 'classes' stamp: 'AlejandraRodriguez 6/24/2013 02:55'!
theTwoLevelSubclassHasNotDefinedTheMethod
	^ SampleSubSubclassD! !

Object subclass: #ProgrammingErrorsDetector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ProgrammingErrorsDetector methodsFor: 'finders' stamp: 'AlejandraRodriguez 6/24/2013 02:08'!
allLeavesSubClassesOf: aClass
	^ aClass allSubclasses select: [:aSubClass | aSubClass subclasses isEmpty]! !

!ProgrammingErrorsDetector methodsFor: 'finders' stamp: 'AlejandraRodriguez 6/24/2013 02:40'!
allSubclassesForWhomIsUndefinedTheMethod: aCompiledMethod 
	| theLeavesSubClassesOfTheMethod theMethodSelector |
	theLeavesSubClassesOfTheMethod := self allLeavesSubClassesOf:  aCompiledMethod methodClass.
	theMethodSelector := aCompiledMethod selector.
	^ theLeavesSubClassesOfTheMethod select: [ :aLeaveSubClass | ((aLeaveSubClass whichClassIncludesSelector: theMethodSelector)>>theMethodSelector) isAbstract ] ! !

!ProgrammingErrorsDetector methodsFor: 'detectors' stamp: 'AlejandraRodriguez 6/24/2013 03:25'!
methodIsUndefinedForSubclases: aCompiledMethod 
	^ aCompiledMethod isAbstract and: [ (self allLeavesSubClassesOf: aCompiledMethod methodClass) isEmpty or: [ (self allSubclassesForWhomIsUndefinedTheMethod: aCompiledMethod) isEmpty not ] ]! !

Object subclass: #SampleClassToTestProgrammingErrorsDetector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleClassToTestProgrammingErrorsDetector methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 18:39'!
nonAbstractMethod
	^ 'Soy un mtodo no abstracto. =D'! !

SampleClassToTestProgrammingErrorsDetector subclass: #SampleClassWithNoSubclasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleClassWithNoSubclasses methodsFor: 'subclassResponsabilityMethods' stamp: 'AlejandraRodriguez 6/21/2013 18:49'!
anAbstractMethod
	^ self subclassResponsibility ! !

!SampleClassWithNoSubclasses methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/24/2013 03:29'!
nonAbstractMethodOfAClassWithoutSubclasses
	^ 'Yo soy un metodo no abstracto!!'! !

SampleClassToTestProgrammingErrorsDetector subclass: #SampleClassWithOneLevelOfSubclasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleClassWithOneLevelOfSubclasses methodsFor: 'subclassResponsabilityMethods' stamp: 'AlejandraRodriguez 6/24/2013 02:52'!
aMethodNotDefinedForOneTheOneLevelSubclasses
	^ self subclassResponsibility ! !

!SampleClassWithOneLevelOfSubclasses methodsFor: 'subclassResponsabilityMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:55'!
aSubclassDefinedMethod
	^ self subclassResponsibility ! !

!SampleClassWithOneLevelOfSubclasses methodsFor: 'subclassResponsabilityMethods' stamp: 'AlejandraRodriguez 6/21/2013 20:26'!
anAbstractMethod
	^ self subclassResponsibility ! !

SampleClassWithOneLevelOfSubclasses subclass: #SampleOneLevelSubClassA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleOneLevelSubClassA methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/24/2013 02:52'!
aMethodNotDefinedForOneTheOneLevelSubclasses
	^ 'En esta subclase si estoy definido!!'! !

!SampleOneLevelSubClassA methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:52'!
aSubclassDefinedMethod
	^ 'Ahora estoy definido!!'! !

SampleClassWithOneLevelOfSubclasses subclass: #SampleOneLevelSubClassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleOneLevelSubClassB methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:53'!
aSubclassDefinedMethod
	^ 'Ahora estoy definido!!'! !

SampleClassToTestProgrammingErrorsDetector subclass: #SampleClassWithTwoLevelsOfSubclasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleClassWithTwoLevelsOfSubclasses methodsFor: 'subclassResponsabilityMethods' stamp: 'AlejandraRodriguez 6/24/2013 03:09'!
aMethodImplementedInOneLevelSubclasses
	^ self subclassResponsibility ! !

!SampleClassWithTwoLevelsOfSubclasses methodsFor: 'subclassResponsabilityMethods' stamp: 'AlejandraRodriguez 6/24/2013 02:52'!
aMethodNotDefinedForOneTheTwoLevelSubclasses
	^ self subclassResponsibility ! !

!SampleClassWithTwoLevelsOfSubclasses methodsFor: 'subclassResponsabilityMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:55'!
aSubclassDefinedMethod
	^ self subclassResponsibility ! !

SampleClassWithTwoLevelsOfSubclasses subclass: #SampleTwoLevelSubclassWhitOneSubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

SampleTwoLevelSubclassWhitOneSubclass subclass: #SampleSubSubclassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleTwoLevelSubclassWhitOneSubclass methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/24/2013 03:10'!
aMethodImplementedInOneLevelSubclasses
	^ 'Estoy implementado en esta clase xq es de nivel uno!!'! !

!SampleTwoLevelSubclassWhitOneSubclass methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/24/2013 02:52'!
aMethodNotDefinedForOneTheTwoLevelSubclasses
	^ 'En esta subclase si estoy definido!!'! !

!SampleTwoLevelSubclassWhitOneSubclass methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:55'!
aSubclassDefinedMethod
	^ 'Ahora estoy definido!!'! !

SampleClassWithTwoLevelsOfSubclasses subclass: #SampleTwoLevelSubclassWithTwoSubclasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

SampleTwoLevelSubclassWithTwoSubclasses subclass: #SampleSubSubclassD
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleSubSubclassD methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:55'!
aSubclassDefinedMethod
	^ 'Ahora estoy definido!!'! !

SampleTwoLevelSubclassWithTwoSubclasses subclass: #SampleSubSubclassE
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleSubSubclassE methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/24/2013 02:52'!
aMethodNotDefinedForOneTheTwoLevelSubclasses
	^ 'En esta subclase si estoy definido!!'! !

!SampleSubSubclassE methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:55'!
aSubclassDefinedMethod
	^ 'Ahora estoy definido!!'! !

!SampleTwoLevelSubclassWithTwoSubclasses methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/24/2013 03:10'!
aMethodImplementedInOneLevelSubclasses
	^ 'Estoy implementado en esta clase xq es de nivel uno!!'! !
